#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXH 10002
#define MAXW 1000
#define MAXK 102
#define FITS_OK 1
#define FITS_NO 2

char map[MAXH+2*MAXK][MAXW];
char keymap[MAXK][MAXK];
char key[MAXK];
int best_so_far,
    lockW,lockH,keyW,keyH;

int WALL (int x, int y)
{
  if ( (x<0) || (x>=lockW) || (y<0) || (y>=lockH+2*keyH) ) return 0;
  return map[y][x]&1;
}

int WASHERE (int x, int y)
{
  if ( (x<0) || (x>=lockW) || (y<0) || (y>=lockH+2*keyH) ) return 0;
  return (map[y][x]>>1)&1;
}

int FITS (int x, int y)
{
  if ( (x<0) || (x>=lockW) || (y<0) || (y>=lockH+2*keyH) ) return 0;
  return map[y][x]>>2;
}

int Fits(int keyX, int keyY)
{
  int x,y;

  if (WASHERE(keyX,keyY)) return 0;
  if (FITS(keyX,keyY)==FITS_OK) return 1;
  if (FITS(keyX,keyY)==FITS_NO) return 0;
  for (x=0;x<keyW;x++)
    for (y=0;y<key[x];y++)
      if (WALL(keyX+x,keyY+x))
      {
        map[keyY+y][keyX+x]|=(FITS_NO<<2);
	return 0;
      }
  map[keyY+y][keyX+x]|=FITS_OK<<2;
  return 1;
}

void Try (int keyX, int keyY)
{
  map[keyY][keyX]|=2;  //washere
  if (keyY>best_so_far) best_so_far=keyY;
  if (keyY==keyH+lockH) return;
  if (Fits(keyX+1,keyY)) Try (keyX+1,keyY);
  if (Fits(keyX-1,keyY)) Try (keyX-1,keyY);
  if (Fits(keyX,keyY+1)) Try (keyX,keyY+1);
}

void ReadKey(void)
{
  int x,y;

  scanf ("%d %d",&keyH,&keyW);
  for (y=0;y<keyH;y++)
    scanf ("%s",(char*)(&keymap[y]));
  for (x=0;x<keyW;x++)
  {
    key[x]=0;
    for (y=keyW-1;y>=0;y--)
      if (keymap[y][x]=='#')
        { key[x]=y+1; break; }
  }
}

void ReadMap(void)
{
  int x,y;

  scanf ("%d %d",&lockH,&lockW);
  memset (map,0,sizeof(map));
  for (y=keyH;y<keyH+lockH;y++)
    scanf("%s",(char*)(&map[y]));
  for (y=keyH;y<keyH+lockH;y++)
    for (x=0;x<lockW;x++)
      if (map[y][x]=='#') map[y][x]=1;
                     else map[y][x]=0;
}

int main(void)
{
  int ncases,x,y;

  scanf ("%d",&ncases);
  while (ncases--)
  {
    ReadKey();
for (y=0;y<keyH;y++) {
for (x=0;x<keyW;x++)

    ReadMap();
    best_so_far=0;
    Try(0,0);
    if (best_so_far==keyH+lockH) printf ("The key can fall through.\n");
           else printf ("The key falls to depth %d.\n",best_so_far);
  }
  return 0;
}


